# Contributors to OpenRCT2
Includes all git commit authors. Aliases are GitHub user names.

## Project team
* Ted John (IntelOrca) - Owner, merger, issue management
* Duncan Frost (duncanspumpkin) - Merger, issue management
* Michael Steenbeek (Gymnasiast) - Translation management
* Rune Laenen (runelaenen) - Translation management
* Miso Zmiric (mzmiric5) - Dependency / library management

## Long term developers
* Ted John (IntelOrca)
* Duncan Frost (duncanspumpkin)
* Michael Steenbeek (Gymnasiast)
* (zsilencer)

## Implementation (RCT2)
* Ted John (IntelOrca)
* Duncan Frost (duncanspumpkin)
* Peter Hill (ZedThree) - String handling, misc.
* (qcz) - Scenery window, misc.
* Matthias Lanzinger (lnz) - Climate, finance, scenario, ride reachability
* (zsilencer) - Audio, multiplayer, misc.
* Adrian Wielgosik (adrian17) - Misc.
* (hexdec) - Misc.
* Dennis Devriendt (ddevrien) - Misc.
* Maciek Baron (MaciekBaron) - Misc.
* (AngeloG) - Scrollbar input, misc.
* (jcdavis) - Misc.
* (marcotc) - Rain drawing, misc.
* (vanderkleij) - Misc.
* Ben Pye (benpye) - Misc.
* (JeroenSack) - Misc.
* (Vijfhoek) - Misc.
* (wolfreak99) - Misc.
* Inseok Lee (dlunch) - Original command line
* Lewis Fox (LRFLEW) - Misc.

## Additional implementation (OpenRCT2)
* (atmaxinger) - User configuration
* (anyc) - Housecleaning, cross-platform fixes
* Michael Steenbeek (Gymnasiast) - Cheats, RCT1 ride style, misc.
* Miso Zmiric (mzmiric5) - Misc.
* (DutchRPW) - Housecleaning, initialisation
* Jørn Lomax (jvlomax) - User configuration
* (KingHual) - Housecleaning
* Alexander Overvoorde (Overv) - Misc.
* (eezstreet) - Misc.
* Thomas den Hollander (ThomasdenH) - Misc.
* James Robertson (rd3k) - Misc.
* Robert Jordan (trigger-death) - UI theming, title sequence editor, misc.
* Aaron van Geffen (AaronVanGeffen) - scenario select screen, font detection, misc.
* Kelson Blakewood - title sequence for 0.0.4

## Bug fixes
* (halfbro)
* (Myrtle)
* (nean)
* Ed Foley (e-foley)
* Michael Pham (nightroan)
* Hielke Morsink (Broxzier)
* Lucas Riutzel (jackinloadup)
* Youngjae Yu (YJSoft)
* Chanwoong Kim (kexplo)
* Josué Acevedo (Wirlie)
* Martin Černáč (octaroot)

## Toolchain
* (Balletie) - OSX
* Kevin Burke (kevinburke) - OSX, Unix
* Miso Zmiric (mzmiric5) - OSX
* Jarno Veuger (JarnoVgr) - Windows build server
* Ted John (IntelOrca) - Windows
* Michał Janiszewski (janisozaur) - Linux, Travis CI
* Lewis Fox (LRFLEW) - OSX

## Documentation
* (honzi)
* Kevin Burke (kevinburke)
* James Robertson (rd3k)
* Max Boße (MakaHost)
* (MaxBareiss)
* Mithun Hunsur (Philpax)
* (RollingStar)

## Translation
* Extracting from original files: Ted John (IntelOrca)
* Reviewing and merging: Rune Laenen (runelaenen), Michael Steenbeek (Gymnasiast)
* Fixing unmaintained languages: Michael Steenbeek (Gymnasiast)
* Miscellaneous fixes: Alexander Overvoorde (Overv), Ed Foley (e-foley)
* English (UK) - Ted John (IntelOrca), (Tinytimrob)
* English (US) - Ted John (IntelOrca), Michael Steenbeek (Gymnasiast); small fixes: LRFLEW, mike-koch
* Czech - Martin Černáč (octaroot), (Clonewayx), Tomáš Pazdiora (Aroidzap)
* Dutch - Michael Steenbeek (Gymnasiast), Yannic Geurts (xzbobzx), (mrtnptrs), Thomas den Hollander (ThomasdenH), (hostbrute),  Marijn van de Werf (marijnvdwerf); reviewing and discussion: Aaron van Geffen (AaronVanGeffen), (Balletie) and Sijmen Schoon (Vijfhoek).
* Finnish - (DJHasis), (Zode), (TheWing)
* French - (fbourigault), Joël Troch (JoelTroch), Michael Steenbeek (Gymnasiast), Romain Vigier (rvgr),  (AziasYur), Hugo Courtial (s0r00t), David Delobel (incyclum)
* German - (danidoedel), (atmaxinger), (Yepoleb), Daniel Kessel (dkessel), Leon (AllGoodNamesAreTaken), (raidcookie)
* Japanese - Aaron van Geffen (AaronVanGeffen), Nick Hall (nickhall), (jhako)
* Korean - "TELK" (telk5093), (NeverDruid); small fixes: (kexplo)
* Polish - Adrian Wielgosik (adrian17), (lopezloo), Michał Janiszewski (janisozaur)
* Portuguese (BR) - (kaudy), (renansimoes)
* Russian - (Soosisya)
* Simplified Chinese - Naiji Ma (naijim), (izhangfei), Eric Zhao (sczyh30)
* Spanish - (mdtrooper), Josué Acevedo (Wirlie), Daniel Trujillo Viedma (gdabi); small fixes: (teapartycthulu)
* Swedish - (Jinxit), (mharrys), (Slimeyo), (Nubbie)
* Traditional Chinese - Harry Lam (daihakken)

## Graphics
* OpenRCT2 Logo - Yannic Geurts (xzbobzx)

## RollerCoaster Tycoon 2 credits
Design and programming by Chris Sawyer
Graphics by Simon Foster
Sound and music by Allister Brimble
Additional sounds recorded by David Ellis
Representation by Jacqui Lyons at Mar jacq Ltd.

Thanks to: Peter James Adcock, Joe Booth, and John Wardley

Licensed to Infogrames Interactive Inc.
